SoMultipleCopy(3)

NAME
SoMultipleCopy - The SoMultipleCopy class redraws its children multiple times at different transformations.

SYNOPSIS

#include <Inventor/nodes/SoMultipleCopy.h>

Inherits SoGroup.

  Public Member Functions
virtual SoType getTypeId (void) const
SoMultipleCopy (void)
virtual SbBool affectsState (void) const
virtual void doAction (SoAction *action)
virtual void callback (SoCallbackAction *action)
virtual void GLRender (SoGLRenderAction *action)
virtual void pick (SoPickAction *action)
virtual void getBoundingBox (SoGetBoundingBoxAction *action)
virtual void handleEvent (SoHandleEventAction *action)
virtual void getMatrix (SoGetMatrixAction *action)
virtual void search (SoSearchAction *action)
virtual void getPrimitiveCount (SoGetPrimitiveCountAction *action)
virtual void audioRender (SoAudioRenderAction *action)

  Static Public Member Functions
static SoType getClassTypeId (void)
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.

  Public Attributes
SoMFMatrix matrix

  Protected Member Functions
virtual const SoFieldData * getFieldData (void) const
virtual ~SoMultipleCopy ()

  Static Protected Member Functions
static const SoFieldData ** getFieldDataPtr (void)

  Additional Inherited Members

Detailed Description

The SoMultipleCopy class redraws its children multiple times at different transformations. The SoMultipleCopy group node duplicates its child nodes / subgraphs without using additional memory resources.

It can do general transformations (translations, rotation and scaling) for its children. Apart from transformations, the appearance of its children will be identical.

FILE FORMAT/DEFAULTS:

MultipleCopy {
    matrix 1 0 0 0
    0 1 0 0
    0 0 1 0
    0 0 0 1
}

See also
    SoArray

Constructor & Destructor Documentation

  SoMultipleCopy::SoMultipleCopy (void)
Constructor.

  SoMultipleCopy::~SoMultipleCopy () [protected], [virtual]
Destructor.

Member Function Documentation

  SoType SoMultipleCopy::getClassTypeId (void) [static]
This static method returns the SoType object associated with objects of this class.

  SoType SoMultipleCopy::getTypeId (void) const [virtual]
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and 'downward' casting.

Reimplemented from SoGroup.

  const SoFieldData ** SoMultipleCopy::getFieldDataPtr (void) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Returns the SoFieldData class which holds information about fields in this node.

  const SoFieldData * SoMultipleCopy::getFieldData (void) const [protected], [virtual]
Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns NULL.

Reimplemented from SoGroup.

  SbBool SoMultipleCopy::affectsState (void) const [virtual]
Returns TRUE if the node could have any effect on the state during traversal.

If it returns FALSE, no data in the traversal state will change from the pre-traversal state to the post-traversal state. The SoSeparator node will for instance return FALSE, as it pushes and pops the state before and after traversal of its children. All SoShape nodes will also return FALSE, as just pushing out geometry data to the rendering engine won't affect the actual rendering state.

The default method returns TRUE, on a 'better safe than sorry' philosophy.

Reimplemented from SoNode.

  void SoMultipleCopy::doAction (SoAction * action) [virtual]
This function performs the typical operation of a node for any action.

Reimplemented from SoGroup.

  void SoMultipleCopy::callback (SoCallbackAction * action) [virtual]
Action method for SoCallbackAction.

Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph.

Reimplemented from SoGroup.

  void SoMultipleCopy::GLRender (SoGLRenderAction * action) [virtual]
Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoGroup.

  void SoMultipleCopy::pick (SoPickAction * action) [virtual]
Action method for SoPickAction.

Does common processing for SoPickAction action instances.

Reimplemented from SoGroup.

  void SoMultipleCopy::getBoundingBox (SoGetBoundingBoxAction * action) [virtual]
Action method for the SoGetBoundingBoxAction.

Calculates bounding box and center coordinates for node and modifies the values of the action to encompass the bounding box for this node and to shift the center point for the scene more towards the one for this node.

Nodes influencing how geometry nodes calculate their bounding box also override this method to change the relevant state variables.

Reimplemented from SoGroup.

  void SoMultipleCopy::handleEvent (SoHandleEventAction * action) [virtual]
Action method for SoHandleEventAction.

Inspects the event data from action, and processes it if it is something which this node should react to.

Nodes influencing relevant state variables for how event handling is done also override this method.

Reimplemented from SoGroup.

  void SoMultipleCopy::getMatrix (SoGetMatrixAction * action) [virtual]
Action method for SoGetMatrixAction.

Updates action by accumulating with the transformation matrix of this node (if any).

Reimplemented from SoGroup.

  void SoMultipleCopy::search (SoSearchAction * action) [virtual]
Action method for SoSearchAction.

Compares the search criteria from the action to see if this node is a match. Searching is done by matching up all criteria set up in the SoSearchAction -- if any of the requested criteria is a miss, the search is not deemed successful for the node.

See also
    SoSearchAction

Reimplemented from SoGroup.

  void SoMultipleCopy::getPrimitiveCount (SoGetPrimitiveCountAction * action) [virtual]
Action method for the SoGetPrimitiveCountAction.

Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action.

Nodes influencing how geometry nodes calculate their primitive count also override this method to change the relevant state variables.

Reimplemented from SoGroup.

  void SoMultipleCopy::audioRender (SoAudioRenderAction * action) [virtual]
Action method for SoAudioRenderAction.

Does common processing for SoAudioRenderAction action instances.

Reimplemented from SoGroup.

Member Data Documentation

  SoMFMatrix SoMultipleCopy::matrix
A set of geometry transformation matrices.

The number of duplicated redraws of the child geometry will be the same as the number of matrices specified in this field. I.e., each duplication will be transformed according to a transformation matrix.

The default value of the field is to contain just a single identity matrix.

Author

Generated automatically by Doxygen for Coin from the source code.